package org.xtext.example.datamodel.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.datamodel.services.DatamodelGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDatamodelParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'context'", "'{'", "'}'", "'extends'", "'-'", "'.'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int RULE_INT=5;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDatamodelParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDatamodelParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDatamodelParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDatamodel.g"; }


    	private DatamodelGrammarAccess grammarAccess;

    	public void setGrammarAccess(DatamodelGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleContext"
    // InternalDatamodel.g:53:1: entryRuleContext : ruleContext EOF ;
    public final void entryRuleContext() throws RecognitionException {
        try {
            // InternalDatamodel.g:54:1: ( ruleContext EOF )
            // InternalDatamodel.g:55:1: ruleContext EOF
            {
             before(grammarAccess.getContextRule()); 
            pushFollow(FOLLOW_1);
            ruleContext();

            state._fsp--;

             after(grammarAccess.getContextRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleContext"


    // $ANTLR start "ruleContext"
    // InternalDatamodel.g:62:1: ruleContext : ( ( rule__Context__Group__0 ) ) ;
    public final void ruleContext() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:66:2: ( ( ( rule__Context__Group__0 ) ) )
            // InternalDatamodel.g:67:2: ( ( rule__Context__Group__0 ) )
            {
            // InternalDatamodel.g:67:2: ( ( rule__Context__Group__0 ) )
            // InternalDatamodel.g:68:3: ( rule__Context__Group__0 )
            {
             before(grammarAccess.getContextAccess().getGroup()); 
            // InternalDatamodel.g:69:3: ( rule__Context__Group__0 )
            // InternalDatamodel.g:69:4: rule__Context__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Context__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getContextAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleContext"


    // $ANTLR start "entryRuleCTXT_FQN"
    // InternalDatamodel.g:78:1: entryRuleCTXT_FQN : ruleCTXT_FQN EOF ;
    public final void entryRuleCTXT_FQN() throws RecognitionException {
         
        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalDatamodel.g:82:1: ( ruleCTXT_FQN EOF )
            // InternalDatamodel.g:83:1: ruleCTXT_FQN EOF
            {
             before(grammarAccess.getCTXT_FQNRule()); 
            pushFollow(FOLLOW_1);
            ruleCTXT_FQN();

            state._fsp--;

             after(grammarAccess.getCTXT_FQNRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "entryRuleCTXT_FQN"


    // $ANTLR start "ruleCTXT_FQN"
    // InternalDatamodel.g:93:1: ruleCTXT_FQN : ( ( rule__CTXT_FQN__Group__0 ) ) ;
    public final void ruleCTXT_FQN() throws RecognitionException {

        		HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();
        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:98:2: ( ( ( rule__CTXT_FQN__Group__0 ) ) )
            // InternalDatamodel.g:99:2: ( ( rule__CTXT_FQN__Group__0 ) )
            {
            // InternalDatamodel.g:99:2: ( ( rule__CTXT_FQN__Group__0 ) )
            // InternalDatamodel.g:100:3: ( rule__CTXT_FQN__Group__0 )
            {
             before(grammarAccess.getCTXT_FQNAccess().getGroup()); 
            // InternalDatamodel.g:101:3: ( rule__CTXT_FQN__Group__0 )
            // InternalDatamodel.g:101:4: rule__CTXT_FQN__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__CTXT_FQN__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getCTXT_FQNAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);
            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "ruleCTXT_FQN"


    // $ANTLR start "entryRuleVERSION"
    // InternalDatamodel.g:111:1: entryRuleVERSION : ruleVERSION EOF ;
    public final void entryRuleVERSION() throws RecognitionException {
         
        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalDatamodel.g:115:1: ( ruleVERSION EOF )
            // InternalDatamodel.g:116:1: ruleVERSION EOF
            {
             before(grammarAccess.getVERSIONRule()); 
            pushFollow(FOLLOW_1);
            ruleVERSION();

            state._fsp--;

             after(grammarAccess.getVERSIONRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "entryRuleVERSION"


    // $ANTLR start "ruleVERSION"
    // InternalDatamodel.g:126:1: ruleVERSION : ( ( rule__VERSION__Group__0 ) ) ;
    public final void ruleVERSION() throws RecognitionException {

        		HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();
        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:131:2: ( ( ( rule__VERSION__Group__0 ) ) )
            // InternalDatamodel.g:132:2: ( ( rule__VERSION__Group__0 ) )
            {
            // InternalDatamodel.g:132:2: ( ( rule__VERSION__Group__0 ) )
            // InternalDatamodel.g:133:3: ( rule__VERSION__Group__0 )
            {
             before(grammarAccess.getVERSIONAccess().getGroup()); 
            // InternalDatamodel.g:134:3: ( rule__VERSION__Group__0 )
            // InternalDatamodel.g:134:4: rule__VERSION__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__VERSION__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getVERSIONAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);
            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "ruleVERSION"


    // $ANTLR start "rule__Context__Group__0"
    // InternalDatamodel.g:143:1: rule__Context__Group__0 : rule__Context__Group__0__Impl rule__Context__Group__1 ;
    public final void rule__Context__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:147:1: ( rule__Context__Group__0__Impl rule__Context__Group__1 )
            // InternalDatamodel.g:148:2: rule__Context__Group__0__Impl rule__Context__Group__1
            {
            pushFollow(FOLLOW_3);
            rule__Context__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__0"


    // $ANTLR start "rule__Context__Group__0__Impl"
    // InternalDatamodel.g:155:1: rule__Context__Group__0__Impl : ( 'context' ) ;
    public final void rule__Context__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:159:1: ( ( 'context' ) )
            // InternalDatamodel.g:160:1: ( 'context' )
            {
            // InternalDatamodel.g:160:1: ( 'context' )
            // InternalDatamodel.g:161:2: 'context'
            {
             before(grammarAccess.getContextAccess().getContextKeyword_0()); 
            match(input,11,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getContextKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__0__Impl"


    // $ANTLR start "rule__Context__Group__1"
    // InternalDatamodel.g:170:1: rule__Context__Group__1 : rule__Context__Group__1__Impl rule__Context__Group__2 ;
    public final void rule__Context__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:174:1: ( rule__Context__Group__1__Impl rule__Context__Group__2 )
            // InternalDatamodel.g:175:2: rule__Context__Group__1__Impl rule__Context__Group__2
            {
            pushFollow(FOLLOW_4);
            rule__Context__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__1"


    // $ANTLR start "rule__Context__Group__1__Impl"
    // InternalDatamodel.g:182:1: rule__Context__Group__1__Impl : ( ( rule__Context__NameAssignment_1 ) ) ;
    public final void rule__Context__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:186:1: ( ( ( rule__Context__NameAssignment_1 ) ) )
            // InternalDatamodel.g:187:1: ( ( rule__Context__NameAssignment_1 ) )
            {
            // InternalDatamodel.g:187:1: ( ( rule__Context__NameAssignment_1 ) )
            // InternalDatamodel.g:188:2: ( rule__Context__NameAssignment_1 )
            {
             before(grammarAccess.getContextAccess().getNameAssignment_1()); 
            // InternalDatamodel.g:189:2: ( rule__Context__NameAssignment_1 )
            // InternalDatamodel.g:189:3: rule__Context__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Context__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getContextAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__1__Impl"


    // $ANTLR start "rule__Context__Group__2"
    // InternalDatamodel.g:197:1: rule__Context__Group__2 : rule__Context__Group__2__Impl rule__Context__Group__3 ;
    public final void rule__Context__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:201:1: ( rule__Context__Group__2__Impl rule__Context__Group__3 )
            // InternalDatamodel.g:202:2: rule__Context__Group__2__Impl rule__Context__Group__3
            {
            pushFollow(FOLLOW_4);
            rule__Context__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__2"


    // $ANTLR start "rule__Context__Group__2__Impl"
    // InternalDatamodel.g:209:1: rule__Context__Group__2__Impl : ( ( rule__Context__Group_2__0 )? ) ;
    public final void rule__Context__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:213:1: ( ( ( rule__Context__Group_2__0 )? ) )
            // InternalDatamodel.g:214:1: ( ( rule__Context__Group_2__0 )? )
            {
            // InternalDatamodel.g:214:1: ( ( rule__Context__Group_2__0 )? )
            // InternalDatamodel.g:215:2: ( rule__Context__Group_2__0 )?
            {
             before(grammarAccess.getContextAccess().getGroup_2()); 
            // InternalDatamodel.g:216:2: ( rule__Context__Group_2__0 )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==14) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalDatamodel.g:216:3: rule__Context__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Context__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getContextAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__2__Impl"


    // $ANTLR start "rule__Context__Group__3"
    // InternalDatamodel.g:224:1: rule__Context__Group__3 : rule__Context__Group__3__Impl rule__Context__Group__4 ;
    public final void rule__Context__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:228:1: ( rule__Context__Group__3__Impl rule__Context__Group__4 )
            // InternalDatamodel.g:229:2: rule__Context__Group__3__Impl rule__Context__Group__4
            {
            pushFollow(FOLLOW_5);
            rule__Context__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__3"


    // $ANTLR start "rule__Context__Group__3__Impl"
    // InternalDatamodel.g:236:1: rule__Context__Group__3__Impl : ( '{' ) ;
    public final void rule__Context__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:240:1: ( ( '{' ) )
            // InternalDatamodel.g:241:1: ( '{' )
            {
            // InternalDatamodel.g:241:1: ( '{' )
            // InternalDatamodel.g:242:2: '{'
            {
             before(grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_3()); 
            match(input,12,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__3__Impl"


    // $ANTLR start "rule__Context__Group__4"
    // InternalDatamodel.g:251:1: rule__Context__Group__4 : rule__Context__Group__4__Impl ;
    public final void rule__Context__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:255:1: ( rule__Context__Group__4__Impl )
            // InternalDatamodel.g:256:2: rule__Context__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Context__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__4"


    // $ANTLR start "rule__Context__Group__4__Impl"
    // InternalDatamodel.g:262:1: rule__Context__Group__4__Impl : ( '}' ) ;
    public final void rule__Context__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:266:1: ( ( '}' ) )
            // InternalDatamodel.g:267:1: ( '}' )
            {
            // InternalDatamodel.g:267:1: ( '}' )
            // InternalDatamodel.g:268:2: '}'
            {
             before(grammarAccess.getContextAccess().getRightCurlyBracketKeyword_4()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__4__Impl"


    // $ANTLR start "rule__Context__Group_2__0"
    // InternalDatamodel.g:278:1: rule__Context__Group_2__0 : rule__Context__Group_2__0__Impl rule__Context__Group_2__1 ;
    public final void rule__Context__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:282:1: ( rule__Context__Group_2__0__Impl rule__Context__Group_2__1 )
            // InternalDatamodel.g:283:2: rule__Context__Group_2__0__Impl rule__Context__Group_2__1
            {
            pushFollow(FOLLOW_3);
            rule__Context__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__0"


    // $ANTLR start "rule__Context__Group_2__0__Impl"
    // InternalDatamodel.g:290:1: rule__Context__Group_2__0__Impl : ( 'extends' ) ;
    public final void rule__Context__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:294:1: ( ( 'extends' ) )
            // InternalDatamodel.g:295:1: ( 'extends' )
            {
            // InternalDatamodel.g:295:1: ( 'extends' )
            // InternalDatamodel.g:296:2: 'extends'
            {
             before(grammarAccess.getContextAccess().getExtendsKeyword_2_0()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getExtendsKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__0__Impl"


    // $ANTLR start "rule__Context__Group_2__1"
    // InternalDatamodel.g:305:1: rule__Context__Group_2__1 : rule__Context__Group_2__1__Impl ;
    public final void rule__Context__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:309:1: ( rule__Context__Group_2__1__Impl )
            // InternalDatamodel.g:310:2: rule__Context__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Context__Group_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__1"


    // $ANTLR start "rule__Context__Group_2__1__Impl"
    // InternalDatamodel.g:316:1: rule__Context__Group_2__1__Impl : ( ( rule__Context__ParentContextAssignment_2_1 ) ) ;
    public final void rule__Context__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:320:1: ( ( ( rule__Context__ParentContextAssignment_2_1 ) ) )
            // InternalDatamodel.g:321:1: ( ( rule__Context__ParentContextAssignment_2_1 ) )
            {
            // InternalDatamodel.g:321:1: ( ( rule__Context__ParentContextAssignment_2_1 ) )
            // InternalDatamodel.g:322:2: ( rule__Context__ParentContextAssignment_2_1 )
            {
             before(grammarAccess.getContextAccess().getParentContextAssignment_2_1()); 
            // InternalDatamodel.g:323:2: ( rule__Context__ParentContextAssignment_2_1 )
            // InternalDatamodel.g:323:3: rule__Context__ParentContextAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Context__ParentContextAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getContextAccess().getParentContextAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__1__Impl"


    // $ANTLR start "rule__CTXT_FQN__Group__0"
    // InternalDatamodel.g:332:1: rule__CTXT_FQN__Group__0 : rule__CTXT_FQN__Group__0__Impl rule__CTXT_FQN__Group__1 ;
    public final void rule__CTXT_FQN__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:336:1: ( rule__CTXT_FQN__Group__0__Impl rule__CTXT_FQN__Group__1 )
            // InternalDatamodel.g:337:2: rule__CTXT_FQN__Group__0__Impl rule__CTXT_FQN__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__CTXT_FQN__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__CTXT_FQN__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__CTXT_FQN__Group__0"


    // $ANTLR start "rule__CTXT_FQN__Group__0__Impl"
    // InternalDatamodel.g:344:1: rule__CTXT_FQN__Group__0__Impl : ( RULE_ID ) ;
    public final void rule__CTXT_FQN__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:348:1: ( ( RULE_ID ) )
            // InternalDatamodel.g:349:1: ( RULE_ID )
            {
            // InternalDatamodel.g:349:1: ( RULE_ID )
            // InternalDatamodel.g:350:2: RULE_ID
            {
             before(grammarAccess.getCTXT_FQNAccess().getIDTerminalRuleCall_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getCTXT_FQNAccess().getIDTerminalRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__CTXT_FQN__Group__0__Impl"


    // $ANTLR start "rule__CTXT_FQN__Group__1"
    // InternalDatamodel.g:359:1: rule__CTXT_FQN__Group__1 : rule__CTXT_FQN__Group__1__Impl rule__CTXT_FQN__Group__2 ;
    public final void rule__CTXT_FQN__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:363:1: ( rule__CTXT_FQN__Group__1__Impl rule__CTXT_FQN__Group__2 )
            // InternalDatamodel.g:364:2: rule__CTXT_FQN__Group__1__Impl rule__CTXT_FQN__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__CTXT_FQN__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__CTXT_FQN__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__CTXT_FQN__Group__1"


    // $ANTLR start "rule__CTXT_FQN__Group__1__Impl"
    // InternalDatamodel.g:371:1: rule__CTXT_FQN__Group__1__Impl : ( '-' ) ;
    public final void rule__CTXT_FQN__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:375:1: ( ( '-' ) )
            // InternalDatamodel.g:376:1: ( '-' )
            {
            // InternalDatamodel.g:376:1: ( '-' )
            // InternalDatamodel.g:377:2: '-'
            {
             before(grammarAccess.getCTXT_FQNAccess().getHyphenMinusKeyword_1()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getCTXT_FQNAccess().getHyphenMinusKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__CTXT_FQN__Group__1__Impl"


    // $ANTLR start "rule__CTXT_FQN__Group__2"
    // InternalDatamodel.g:386:1: rule__CTXT_FQN__Group__2 : rule__CTXT_FQN__Group__2__Impl ;
    public final void rule__CTXT_FQN__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:390:1: ( rule__CTXT_FQN__Group__2__Impl )
            // InternalDatamodel.g:391:2: rule__CTXT_FQN__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__CTXT_FQN__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__CTXT_FQN__Group__2"


    // $ANTLR start "rule__CTXT_FQN__Group__2__Impl"
    // InternalDatamodel.g:397:1: rule__CTXT_FQN__Group__2__Impl : ( ruleVERSION ) ;
    public final void rule__CTXT_FQN__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:401:1: ( ( ruleVERSION ) )
            // InternalDatamodel.g:402:1: ( ruleVERSION )
            {
            // InternalDatamodel.g:402:1: ( ruleVERSION )
            // InternalDatamodel.g:403:2: ruleVERSION
            {
             before(grammarAccess.getCTXT_FQNAccess().getVERSIONParserRuleCall_2()); 
            pushFollow(FOLLOW_2);
            ruleVERSION();

            state._fsp--;

             after(grammarAccess.getCTXT_FQNAccess().getVERSIONParserRuleCall_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__CTXT_FQN__Group__2__Impl"


    // $ANTLR start "rule__VERSION__Group__0"
    // InternalDatamodel.g:413:1: rule__VERSION__Group__0 : rule__VERSION__Group__0__Impl rule__VERSION__Group__1 ;
    public final void rule__VERSION__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:417:1: ( rule__VERSION__Group__0__Impl rule__VERSION__Group__1 )
            // InternalDatamodel.g:418:2: rule__VERSION__Group__0__Impl rule__VERSION__Group__1
            {
            pushFollow(FOLLOW_8);
            rule__VERSION__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__VERSION__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__0"


    // $ANTLR start "rule__VERSION__Group__0__Impl"
    // InternalDatamodel.g:425:1: rule__VERSION__Group__0__Impl : ( RULE_INT ) ;
    public final void rule__VERSION__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:429:1: ( ( RULE_INT ) )
            // InternalDatamodel.g:430:1: ( RULE_INT )
            {
            // InternalDatamodel.g:430:1: ( RULE_INT )
            // InternalDatamodel.g:431:2: RULE_INT
            {
             before(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_0()); 
            match(input,RULE_INT,FOLLOW_2); 
             after(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__0__Impl"


    // $ANTLR start "rule__VERSION__Group__1"
    // InternalDatamodel.g:440:1: rule__VERSION__Group__1 : rule__VERSION__Group__1__Impl rule__VERSION__Group__2 ;
    public final void rule__VERSION__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:444:1: ( rule__VERSION__Group__1__Impl rule__VERSION__Group__2 )
            // InternalDatamodel.g:445:2: rule__VERSION__Group__1__Impl rule__VERSION__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__VERSION__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__VERSION__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__1"


    // $ANTLR start "rule__VERSION__Group__1__Impl"
    // InternalDatamodel.g:452:1: rule__VERSION__Group__1__Impl : ( '.' ) ;
    public final void rule__VERSION__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:456:1: ( ( '.' ) )
            // InternalDatamodel.g:457:1: ( '.' )
            {
            // InternalDatamodel.g:457:1: ( '.' )
            // InternalDatamodel.g:458:2: '.'
            {
             before(grammarAccess.getVERSIONAccess().getFullStopKeyword_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getVERSIONAccess().getFullStopKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__1__Impl"


    // $ANTLR start "rule__VERSION__Group__2"
    // InternalDatamodel.g:467:1: rule__VERSION__Group__2 : rule__VERSION__Group__2__Impl rule__VERSION__Group__3 ;
    public final void rule__VERSION__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:471:1: ( rule__VERSION__Group__2__Impl rule__VERSION__Group__3 )
            // InternalDatamodel.g:472:2: rule__VERSION__Group__2__Impl rule__VERSION__Group__3
            {
            pushFollow(FOLLOW_8);
            rule__VERSION__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__VERSION__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__2"


    // $ANTLR start "rule__VERSION__Group__2__Impl"
    // InternalDatamodel.g:479:1: rule__VERSION__Group__2__Impl : ( RULE_INT ) ;
    public final void rule__VERSION__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:483:1: ( ( RULE_INT ) )
            // InternalDatamodel.g:484:1: ( RULE_INT )
            {
            // InternalDatamodel.g:484:1: ( RULE_INT )
            // InternalDatamodel.g:485:2: RULE_INT
            {
             before(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_2()); 
            match(input,RULE_INT,FOLLOW_2); 
             after(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__2__Impl"


    // $ANTLR start "rule__VERSION__Group__3"
    // InternalDatamodel.g:494:1: rule__VERSION__Group__3 : rule__VERSION__Group__3__Impl rule__VERSION__Group__4 ;
    public final void rule__VERSION__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:498:1: ( rule__VERSION__Group__3__Impl rule__VERSION__Group__4 )
            // InternalDatamodel.g:499:2: rule__VERSION__Group__3__Impl rule__VERSION__Group__4
            {
            pushFollow(FOLLOW_7);
            rule__VERSION__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__VERSION__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__3"


    // $ANTLR start "rule__VERSION__Group__3__Impl"
    // InternalDatamodel.g:506:1: rule__VERSION__Group__3__Impl : ( '.' ) ;
    public final void rule__VERSION__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:510:1: ( ( '.' ) )
            // InternalDatamodel.g:511:1: ( '.' )
            {
            // InternalDatamodel.g:511:1: ( '.' )
            // InternalDatamodel.g:512:2: '.'
            {
             before(grammarAccess.getVERSIONAccess().getFullStopKeyword_3()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getVERSIONAccess().getFullStopKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__3__Impl"


    // $ANTLR start "rule__VERSION__Group__4"
    // InternalDatamodel.g:521:1: rule__VERSION__Group__4 : rule__VERSION__Group__4__Impl rule__VERSION__Group__5 ;
    public final void rule__VERSION__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:525:1: ( rule__VERSION__Group__4__Impl rule__VERSION__Group__5 )
            // InternalDatamodel.g:526:2: rule__VERSION__Group__4__Impl rule__VERSION__Group__5
            {
            pushFollow(FOLLOW_8);
            rule__VERSION__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__VERSION__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__4"


    // $ANTLR start "rule__VERSION__Group__4__Impl"
    // InternalDatamodel.g:533:1: rule__VERSION__Group__4__Impl : ( RULE_INT ) ;
    public final void rule__VERSION__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:537:1: ( ( RULE_INT ) )
            // InternalDatamodel.g:538:1: ( RULE_INT )
            {
            // InternalDatamodel.g:538:1: ( RULE_INT )
            // InternalDatamodel.g:539:2: RULE_INT
            {
             before(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_4()); 
            match(input,RULE_INT,FOLLOW_2); 
             after(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__4__Impl"


    // $ANTLR start "rule__VERSION__Group__5"
    // InternalDatamodel.g:548:1: rule__VERSION__Group__5 : rule__VERSION__Group__5__Impl ;
    public final void rule__VERSION__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:552:1: ( rule__VERSION__Group__5__Impl )
            // InternalDatamodel.g:553:2: rule__VERSION__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__VERSION__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__5"


    // $ANTLR start "rule__VERSION__Group__5__Impl"
    // InternalDatamodel.g:559:1: rule__VERSION__Group__5__Impl : ( ( rule__VERSION__Group_5__0 )? ) ;
    public final void rule__VERSION__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:563:1: ( ( ( rule__VERSION__Group_5__0 )? ) )
            // InternalDatamodel.g:564:1: ( ( rule__VERSION__Group_5__0 )? )
            {
            // InternalDatamodel.g:564:1: ( ( rule__VERSION__Group_5__0 )? )
            // InternalDatamodel.g:565:2: ( rule__VERSION__Group_5__0 )?
            {
             before(grammarAccess.getVERSIONAccess().getGroup_5()); 
            // InternalDatamodel.g:566:2: ( rule__VERSION__Group_5__0 )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==16) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDatamodel.g:566:3: rule__VERSION__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__VERSION__Group_5__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getVERSIONAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group__5__Impl"


    // $ANTLR start "rule__VERSION__Group_5__0"
    // InternalDatamodel.g:575:1: rule__VERSION__Group_5__0 : rule__VERSION__Group_5__0__Impl rule__VERSION__Group_5__1 ;
    public final void rule__VERSION__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:579:1: ( rule__VERSION__Group_5__0__Impl rule__VERSION__Group_5__1 )
            // InternalDatamodel.g:580:2: rule__VERSION__Group_5__0__Impl rule__VERSION__Group_5__1
            {
            pushFollow(FOLLOW_7);
            rule__VERSION__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__VERSION__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group_5__0"


    // $ANTLR start "rule__VERSION__Group_5__0__Impl"
    // InternalDatamodel.g:587:1: rule__VERSION__Group_5__0__Impl : ( '.' ) ;
    public final void rule__VERSION__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:591:1: ( ( '.' ) )
            // InternalDatamodel.g:592:1: ( '.' )
            {
            // InternalDatamodel.g:592:1: ( '.' )
            // InternalDatamodel.g:593:2: '.'
            {
             before(grammarAccess.getVERSIONAccess().getFullStopKeyword_5_0()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getVERSIONAccess().getFullStopKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group_5__0__Impl"


    // $ANTLR start "rule__VERSION__Group_5__1"
    // InternalDatamodel.g:602:1: rule__VERSION__Group_5__1 : rule__VERSION__Group_5__1__Impl ;
    public final void rule__VERSION__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:606:1: ( rule__VERSION__Group_5__1__Impl )
            // InternalDatamodel.g:607:2: rule__VERSION__Group_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__VERSION__Group_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group_5__1"


    // $ANTLR start "rule__VERSION__Group_5__1__Impl"
    // InternalDatamodel.g:613:1: rule__VERSION__Group_5__1__Impl : ( RULE_INT ) ;
    public final void rule__VERSION__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:617:1: ( ( RULE_INT ) )
            // InternalDatamodel.g:618:1: ( RULE_INT )
            {
            // InternalDatamodel.g:618:1: ( RULE_INT )
            // InternalDatamodel.g:619:2: RULE_INT
            {
             before(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_5_1()); 
            match(input,RULE_INT,FOLLOW_2); 
             after(grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__VERSION__Group_5__1__Impl"


    // $ANTLR start "rule__Context__NameAssignment_1"
    // InternalDatamodel.g:629:1: rule__Context__NameAssignment_1 : ( ruleCTXT_FQN ) ;
    public final void rule__Context__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:633:1: ( ( ruleCTXT_FQN ) )
            // InternalDatamodel.g:634:2: ( ruleCTXT_FQN )
            {
            // InternalDatamodel.g:634:2: ( ruleCTXT_FQN )
            // InternalDatamodel.g:635:3: ruleCTXT_FQN
            {
             before(grammarAccess.getContextAccess().getNameCTXT_FQNParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleCTXT_FQN();

            state._fsp--;

             after(grammarAccess.getContextAccess().getNameCTXT_FQNParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__NameAssignment_1"


    // $ANTLR start "rule__Context__ParentContextAssignment_2_1"
    // InternalDatamodel.g:644:1: rule__Context__ParentContextAssignment_2_1 : ( ( ruleCTXT_FQN ) ) ;
    public final void rule__Context__ParentContextAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:648:1: ( ( ( ruleCTXT_FQN ) ) )
            // InternalDatamodel.g:649:2: ( ( ruleCTXT_FQN ) )
            {
            // InternalDatamodel.g:649:2: ( ( ruleCTXT_FQN ) )
            // InternalDatamodel.g:650:3: ( ruleCTXT_FQN )
            {
             before(grammarAccess.getContextAccess().getParentContextContextCrossReference_2_1_0()); 
            // InternalDatamodel.g:651:3: ( ruleCTXT_FQN )
            // InternalDatamodel.g:652:4: ruleCTXT_FQN
            {
             before(grammarAccess.getContextAccess().getParentContextContextCTXT_FQNParserRuleCall_2_1_0_1()); 
            pushFollow(FOLLOW_2);
            ruleCTXT_FQN();

            state._fsp--;

             after(grammarAccess.getContextAccess().getParentContextContextCTXT_FQNParserRuleCall_2_1_0_1()); 

            }

             after(grammarAccess.getContextAccess().getParentContextContextCrossReference_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__ParentContextAssignment_2_1"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000005000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000010000L});

}