package org.xtext.example.datamodel.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.datamodel.services.DatamodelGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDatamodelParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'context'", "'extends'", "'{'", "'}'", "'-'", "'.'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int RULE_INT=5;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDatamodelParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDatamodelParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDatamodelParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDatamodel.g"; }



     	private DatamodelGrammarAccess grammarAccess;

        public InternalDatamodelParser(TokenStream input, DatamodelGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Context";
       	}

       	@Override
       	protected DatamodelGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleContext"
    // InternalDatamodel.g:64:1: entryRuleContext returns [EObject current=null] : iv_ruleContext= ruleContext EOF ;
    public final EObject entryRuleContext() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleContext = null;


        try {
            // InternalDatamodel.g:64:48: (iv_ruleContext= ruleContext EOF )
            // InternalDatamodel.g:65:2: iv_ruleContext= ruleContext EOF
            {
             newCompositeNode(grammarAccess.getContextRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleContext=ruleContext();

            state._fsp--;

             current =iv_ruleContext; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleContext"


    // $ANTLR start "ruleContext"
    // InternalDatamodel.g:71:1: ruleContext returns [EObject current=null] : (otherlv_0= 'context' ( (lv_name_1_0= ruleCTXT_FQN ) ) (otherlv_2= 'extends' ( ( ruleCTXT_FQN ) ) )? otherlv_4= '{' otherlv_5= '}' ) ;
    public final EObject ruleContext() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;



        	enterRule();

        try {
            // InternalDatamodel.g:77:2: ( (otherlv_0= 'context' ( (lv_name_1_0= ruleCTXT_FQN ) ) (otherlv_2= 'extends' ( ( ruleCTXT_FQN ) ) )? otherlv_4= '{' otherlv_5= '}' ) )
            // InternalDatamodel.g:78:2: (otherlv_0= 'context' ( (lv_name_1_0= ruleCTXT_FQN ) ) (otherlv_2= 'extends' ( ( ruleCTXT_FQN ) ) )? otherlv_4= '{' otherlv_5= '}' )
            {
            // InternalDatamodel.g:78:2: (otherlv_0= 'context' ( (lv_name_1_0= ruleCTXT_FQN ) ) (otherlv_2= 'extends' ( ( ruleCTXT_FQN ) ) )? otherlv_4= '{' otherlv_5= '}' )
            // InternalDatamodel.g:79:3: otherlv_0= 'context' ( (lv_name_1_0= ruleCTXT_FQN ) ) (otherlv_2= 'extends' ( ( ruleCTXT_FQN ) ) )? otherlv_4= '{' otherlv_5= '}'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_3); 

            			newLeafNode(otherlv_0, grammarAccess.getContextAccess().getContextKeyword_0());
            		
            // InternalDatamodel.g:83:3: ( (lv_name_1_0= ruleCTXT_FQN ) )
            // InternalDatamodel.g:84:4: (lv_name_1_0= ruleCTXT_FQN )
            {
            // InternalDatamodel.g:84:4: (lv_name_1_0= ruleCTXT_FQN )
            // InternalDatamodel.g:85:5: lv_name_1_0= ruleCTXT_FQN
            {

            					newCompositeNode(grammarAccess.getContextAccess().getNameCTXT_FQNParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_4);
            lv_name_1_0=ruleCTXT_FQN();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getContextRule());
            					}
            					set(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.xtext.example.datamodel.Datamodel.CTXT_FQN");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDatamodel.g:102:3: (otherlv_2= 'extends' ( ( ruleCTXT_FQN ) ) )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==12) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalDatamodel.g:103:4: otherlv_2= 'extends' ( ( ruleCTXT_FQN ) )
                    {
                    otherlv_2=(Token)match(input,12,FOLLOW_3); 

                    				newLeafNode(otherlv_2, grammarAccess.getContextAccess().getExtendsKeyword_2_0());
                    			
                    // InternalDatamodel.g:107:4: ( ( ruleCTXT_FQN ) )
                    // InternalDatamodel.g:108:5: ( ruleCTXT_FQN )
                    {
                    // InternalDatamodel.g:108:5: ( ruleCTXT_FQN )
                    // InternalDatamodel.g:109:6: ruleCTXT_FQN
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getContextRule());
                    						}
                    					

                    						newCompositeNode(grammarAccess.getContextAccess().getParentContextContextCrossReference_2_1_0());
                    					
                    pushFollow(FOLLOW_5);
                    ruleCTXT_FQN();

                    state._fsp--;


                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_4=(Token)match(input,13,FOLLOW_6); 

            			newLeafNode(otherlv_4, grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_3());
            		
            otherlv_5=(Token)match(input,14,FOLLOW_2); 

            			newLeafNode(otherlv_5, grammarAccess.getContextAccess().getRightCurlyBracketKeyword_4());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleContext"


    // $ANTLR start "entryRuleCTXT_FQN"
    // InternalDatamodel.g:136:1: entryRuleCTXT_FQN returns [String current=null] : iv_ruleCTXT_FQN= ruleCTXT_FQN EOF ;
    public final String entryRuleCTXT_FQN() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleCTXT_FQN = null;



        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalDatamodel.g:138:2: (iv_ruleCTXT_FQN= ruleCTXT_FQN EOF )
            // InternalDatamodel.g:139:2: iv_ruleCTXT_FQN= ruleCTXT_FQN EOF
            {
             newCompositeNode(grammarAccess.getCTXT_FQNRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleCTXT_FQN=ruleCTXT_FQN();

            state._fsp--;

             current =iv_ruleCTXT_FQN.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {

            	myHiddenTokenState.restore();

        }
        return current;
    }
    // $ANTLR end "entryRuleCTXT_FQN"


    // $ANTLR start "ruleCTXT_FQN"
    // InternalDatamodel.g:148:1: ruleCTXT_FQN returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_ID_0= RULE_ID kw= '-' this_VERSION_2= ruleVERSION ) ;
    public final AntlrDatatypeRuleToken ruleCTXT_FQN() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_ID_0=null;
        Token kw=null;
        AntlrDatatypeRuleToken this_VERSION_2 = null;



        	enterRule();
        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalDatamodel.g:155:2: ( (this_ID_0= RULE_ID kw= '-' this_VERSION_2= ruleVERSION ) )
            // InternalDatamodel.g:156:2: (this_ID_0= RULE_ID kw= '-' this_VERSION_2= ruleVERSION )
            {
            // InternalDatamodel.g:156:2: (this_ID_0= RULE_ID kw= '-' this_VERSION_2= ruleVERSION )
            // InternalDatamodel.g:157:3: this_ID_0= RULE_ID kw= '-' this_VERSION_2= ruleVERSION
            {
            this_ID_0=(Token)match(input,RULE_ID,FOLLOW_7); 

            			current.merge(this_ID_0);
            		

            			newLeafNode(this_ID_0, grammarAccess.getCTXT_FQNAccess().getIDTerminalRuleCall_0());
            		
            kw=(Token)match(input,15,FOLLOW_8); 

            			current.merge(kw);
            			newLeafNode(kw, grammarAccess.getCTXT_FQNAccess().getHyphenMinusKeyword_1());
            		

            			newCompositeNode(grammarAccess.getCTXT_FQNAccess().getVERSIONParserRuleCall_2());
            		
            pushFollow(FOLLOW_2);
            this_VERSION_2=ruleVERSION();

            state._fsp--;


            			current.merge(this_VERSION_2);
            		

            			afterParserOrEnumRuleCall();
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {

            	myHiddenTokenState.restore();

        }
        return current;
    }
    // $ANTLR end "ruleCTXT_FQN"


    // $ANTLR start "entryRuleVERSION"
    // InternalDatamodel.g:186:1: entryRuleVERSION returns [String current=null] : iv_ruleVERSION= ruleVERSION EOF ;
    public final String entryRuleVERSION() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleVERSION = null;



        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalDatamodel.g:188:2: (iv_ruleVERSION= ruleVERSION EOF )
            // InternalDatamodel.g:189:2: iv_ruleVERSION= ruleVERSION EOF
            {
             newCompositeNode(grammarAccess.getVERSIONRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleVERSION=ruleVERSION();

            state._fsp--;

             current =iv_ruleVERSION.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {

            	myHiddenTokenState.restore();

        }
        return current;
    }
    // $ANTLR end "entryRuleVERSION"


    // $ANTLR start "ruleVERSION"
    // InternalDatamodel.g:198:1: ruleVERSION returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= '.' this_INT_4= RULE_INT (kw= '.' this_INT_6= RULE_INT )? ) ;
    public final AntlrDatatypeRuleToken ruleVERSION() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        Token kw=null;
        Token this_INT_2=null;
        Token this_INT_4=null;
        Token this_INT_6=null;


        	enterRule();
        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalDatamodel.g:205:2: ( (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= '.' this_INT_4= RULE_INT (kw= '.' this_INT_6= RULE_INT )? ) )
            // InternalDatamodel.g:206:2: (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= '.' this_INT_4= RULE_INT (kw= '.' this_INT_6= RULE_INT )? )
            {
            // InternalDatamodel.g:206:2: (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= '.' this_INT_4= RULE_INT (kw= '.' this_INT_6= RULE_INT )? )
            // InternalDatamodel.g:207:3: this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= '.' this_INT_4= RULE_INT (kw= '.' this_INT_6= RULE_INT )?
            {
            this_INT_0=(Token)match(input,RULE_INT,FOLLOW_9); 

            			current.merge(this_INT_0);
            		

            			newLeafNode(this_INT_0, grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_0());
            		
            kw=(Token)match(input,16,FOLLOW_8); 

            			current.merge(kw);
            			newLeafNode(kw, grammarAccess.getVERSIONAccess().getFullStopKeyword_1());
            		
            this_INT_2=(Token)match(input,RULE_INT,FOLLOW_9); 

            			current.merge(this_INT_2);
            		

            			newLeafNode(this_INT_2, grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_2());
            		
            kw=(Token)match(input,16,FOLLOW_8); 

            			current.merge(kw);
            			newLeafNode(kw, grammarAccess.getVERSIONAccess().getFullStopKeyword_3());
            		
            this_INT_4=(Token)match(input,RULE_INT,FOLLOW_10); 

            			current.merge(this_INT_4);
            		

            			newLeafNode(this_INT_4, grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_4());
            		
            // InternalDatamodel.g:238:3: (kw= '.' this_INT_6= RULE_INT )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==16) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDatamodel.g:239:4: kw= '.' this_INT_6= RULE_INT
                    {
                    kw=(Token)match(input,16,FOLLOW_8); 

                    				current.merge(kw);
                    				newLeafNode(kw, grammarAccess.getVERSIONAccess().getFullStopKeyword_5_0());
                    			
                    this_INT_6=(Token)match(input,RULE_INT,FOLLOW_2); 

                    				current.merge(this_INT_6);
                    			

                    				newLeafNode(this_INT_6, grammarAccess.getVERSIONAccess().getINTTerminalRuleCall_5_1());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {

            	myHiddenTokenState.restore();

        }
        return current;
    }
    // $ANTLR end "ruleVERSION"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000003000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000010002L});

}