package org.xtext.example.model.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.model.services.ModelGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalModelParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_MODEL_ID", "RULE_VERSION", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'model'", "'{'", "'name'", "'version'", "'}'", "'extends'"
    };
    public static final int RULE_ID=6;
    public static final int RULE_WS=11;
    public static final int RULE_STRING=8;
    public static final int RULE_ANY_OTHER=12;
    public static final int RULE_SL_COMMENT=10;
    public static final int RULE_VERSION=5;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=7;
    public static final int T__18=18;
    public static final int RULE_ML_COMMENT=9;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int RULE_MODEL_ID=4;

    // delegates
    // delegators


        public InternalModelParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalModelParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalModelParser.tokenNames; }
    public String getGrammarFileName() { return "InternalModel.g"; }


    	private ModelGrammarAccess grammarAccess;

    	public void setGrammarAccess(ModelGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleModel"
    // InternalModel.g:53:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // InternalModel.g:54:1: ( ruleModel EOF )
            // InternalModel.g:55:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            ruleModel();

            state._fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalModel.g:62:1: ruleModel : ( ( rule__Model__Group__0 ) ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:66:2: ( ( ( rule__Model__Group__0 ) ) )
            // InternalModel.g:67:2: ( ( rule__Model__Group__0 ) )
            {
            // InternalModel.g:67:2: ( ( rule__Model__Group__0 ) )
            // InternalModel.g:68:3: ( rule__Model__Group__0 )
            {
             before(grammarAccess.getModelAccess().getGroup()); 
            // InternalModel.g:69:3: ( rule__Model__Group__0 )
            // InternalModel.g:69:4: rule__Model__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Model__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getModelAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "rule__Model__Group__0"
    // InternalModel.g:77:1: rule__Model__Group__0 : rule__Model__Group__0__Impl rule__Model__Group__1 ;
    public final void rule__Model__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:81:1: ( rule__Model__Group__0__Impl rule__Model__Group__1 )
            // InternalModel.g:82:2: rule__Model__Group__0__Impl rule__Model__Group__1
            {
            pushFollow(FOLLOW_3);
            rule__Model__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__0"


    // $ANTLR start "rule__Model__Group__0__Impl"
    // InternalModel.g:89:1: rule__Model__Group__0__Impl : ( 'model' ) ;
    public final void rule__Model__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:93:1: ( ( 'model' ) )
            // InternalModel.g:94:1: ( 'model' )
            {
            // InternalModel.g:94:1: ( 'model' )
            // InternalModel.g:95:2: 'model'
            {
             before(grammarAccess.getModelAccess().getModelKeyword_0()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getModelKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__0__Impl"


    // $ANTLR start "rule__Model__Group__1"
    // InternalModel.g:104:1: rule__Model__Group__1 : rule__Model__Group__1__Impl rule__Model__Group__2 ;
    public final void rule__Model__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:108:1: ( rule__Model__Group__1__Impl rule__Model__Group__2 )
            // InternalModel.g:109:2: rule__Model__Group__1__Impl rule__Model__Group__2
            {
            pushFollow(FOLLOW_4);
            rule__Model__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__1"


    // $ANTLR start "rule__Model__Group__1__Impl"
    // InternalModel.g:116:1: rule__Model__Group__1__Impl : ( '{' ) ;
    public final void rule__Model__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:120:1: ( ( '{' ) )
            // InternalModel.g:121:1: ( '{' )
            {
            // InternalModel.g:121:1: ( '{' )
            // InternalModel.g:122:2: '{'
            {
             before(grammarAccess.getModelAccess().getLeftCurlyBracketKeyword_1()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getLeftCurlyBracketKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__1__Impl"


    // $ANTLR start "rule__Model__Group__2"
    // InternalModel.g:131:1: rule__Model__Group__2 : rule__Model__Group__2__Impl rule__Model__Group__3 ;
    public final void rule__Model__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:135:1: ( rule__Model__Group__2__Impl rule__Model__Group__3 )
            // InternalModel.g:136:2: rule__Model__Group__2__Impl rule__Model__Group__3
            {
            pushFollow(FOLLOW_5);
            rule__Model__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__2"


    // $ANTLR start "rule__Model__Group__2__Impl"
    // InternalModel.g:143:1: rule__Model__Group__2__Impl : ( 'name' ) ;
    public final void rule__Model__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:147:1: ( ( 'name' ) )
            // InternalModel.g:148:1: ( 'name' )
            {
            // InternalModel.g:148:1: ( 'name' )
            // InternalModel.g:149:2: 'name'
            {
             before(grammarAccess.getModelAccess().getNameKeyword_2()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getNameKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__2__Impl"


    // $ANTLR start "rule__Model__Group__3"
    // InternalModel.g:158:1: rule__Model__Group__3 : rule__Model__Group__3__Impl rule__Model__Group__4 ;
    public final void rule__Model__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:162:1: ( rule__Model__Group__3__Impl rule__Model__Group__4 )
            // InternalModel.g:163:2: rule__Model__Group__3__Impl rule__Model__Group__4
            {
            pushFollow(FOLLOW_6);
            rule__Model__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__3"


    // $ANTLR start "rule__Model__Group__3__Impl"
    // InternalModel.g:170:1: rule__Model__Group__3__Impl : ( ( rule__Model__NameAssignment_3 ) ) ;
    public final void rule__Model__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:174:1: ( ( ( rule__Model__NameAssignment_3 ) ) )
            // InternalModel.g:175:1: ( ( rule__Model__NameAssignment_3 ) )
            {
            // InternalModel.g:175:1: ( ( rule__Model__NameAssignment_3 ) )
            // InternalModel.g:176:2: ( rule__Model__NameAssignment_3 )
            {
             before(grammarAccess.getModelAccess().getNameAssignment_3()); 
            // InternalModel.g:177:2: ( rule__Model__NameAssignment_3 )
            // InternalModel.g:177:3: rule__Model__NameAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__Model__NameAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getModelAccess().getNameAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__3__Impl"


    // $ANTLR start "rule__Model__Group__4"
    // InternalModel.g:185:1: rule__Model__Group__4 : rule__Model__Group__4__Impl rule__Model__Group__5 ;
    public final void rule__Model__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:189:1: ( rule__Model__Group__4__Impl rule__Model__Group__5 )
            // InternalModel.g:190:2: rule__Model__Group__4__Impl rule__Model__Group__5
            {
            pushFollow(FOLLOW_6);
            rule__Model__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__4"


    // $ANTLR start "rule__Model__Group__4__Impl"
    // InternalModel.g:197:1: rule__Model__Group__4__Impl : ( ( rule__Model__Group_4__0 )? ) ;
    public final void rule__Model__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:201:1: ( ( ( rule__Model__Group_4__0 )? ) )
            // InternalModel.g:202:1: ( ( rule__Model__Group_4__0 )? )
            {
            // InternalModel.g:202:1: ( ( rule__Model__Group_4__0 )? )
            // InternalModel.g:203:2: ( rule__Model__Group_4__0 )?
            {
             before(grammarAccess.getModelAccess().getGroup_4()); 
            // InternalModel.g:204:2: ( rule__Model__Group_4__0 )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==18) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalModel.g:204:3: rule__Model__Group_4__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Model__Group_4__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getModelAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__4__Impl"


    // $ANTLR start "rule__Model__Group__5"
    // InternalModel.g:212:1: rule__Model__Group__5 : rule__Model__Group__5__Impl rule__Model__Group__6 ;
    public final void rule__Model__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:216:1: ( rule__Model__Group__5__Impl rule__Model__Group__6 )
            // InternalModel.g:217:2: rule__Model__Group__5__Impl rule__Model__Group__6
            {
            pushFollow(FOLLOW_7);
            rule__Model__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__5"


    // $ANTLR start "rule__Model__Group__5__Impl"
    // InternalModel.g:224:1: rule__Model__Group__5__Impl : ( 'version' ) ;
    public final void rule__Model__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:228:1: ( ( 'version' ) )
            // InternalModel.g:229:1: ( 'version' )
            {
            // InternalModel.g:229:1: ( 'version' )
            // InternalModel.g:230:2: 'version'
            {
             before(grammarAccess.getModelAccess().getVersionKeyword_5()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getVersionKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__5__Impl"


    // $ANTLR start "rule__Model__Group__6"
    // InternalModel.g:239:1: rule__Model__Group__6 : rule__Model__Group__6__Impl rule__Model__Group__7 ;
    public final void rule__Model__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:243:1: ( rule__Model__Group__6__Impl rule__Model__Group__7 )
            // InternalModel.g:244:2: rule__Model__Group__6__Impl rule__Model__Group__7
            {
            pushFollow(FOLLOW_8);
            rule__Model__Group__6__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group__7();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__6"


    // $ANTLR start "rule__Model__Group__6__Impl"
    // InternalModel.g:251:1: rule__Model__Group__6__Impl : ( ( rule__Model__VersionAssignment_6 ) ) ;
    public final void rule__Model__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:255:1: ( ( ( rule__Model__VersionAssignment_6 ) ) )
            // InternalModel.g:256:1: ( ( rule__Model__VersionAssignment_6 ) )
            {
            // InternalModel.g:256:1: ( ( rule__Model__VersionAssignment_6 ) )
            // InternalModel.g:257:2: ( rule__Model__VersionAssignment_6 )
            {
             before(grammarAccess.getModelAccess().getVersionAssignment_6()); 
            // InternalModel.g:258:2: ( rule__Model__VersionAssignment_6 )
            // InternalModel.g:258:3: rule__Model__VersionAssignment_6
            {
            pushFollow(FOLLOW_2);
            rule__Model__VersionAssignment_6();

            state._fsp--;


            }

             after(grammarAccess.getModelAccess().getVersionAssignment_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__6__Impl"


    // $ANTLR start "rule__Model__Group__7"
    // InternalModel.g:266:1: rule__Model__Group__7 : rule__Model__Group__7__Impl ;
    public final void rule__Model__Group__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:270:1: ( rule__Model__Group__7__Impl )
            // InternalModel.g:271:2: rule__Model__Group__7__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Model__Group__7__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__7"


    // $ANTLR start "rule__Model__Group__7__Impl"
    // InternalModel.g:277:1: rule__Model__Group__7__Impl : ( '}' ) ;
    public final void rule__Model__Group__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:281:1: ( ( '}' ) )
            // InternalModel.g:282:1: ( '}' )
            {
            // InternalModel.g:282:1: ( '}' )
            // InternalModel.g:283:2: '}'
            {
             before(grammarAccess.getModelAccess().getRightCurlyBracketKeyword_7()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getRightCurlyBracketKeyword_7()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__7__Impl"


    // $ANTLR start "rule__Model__Group_4__0"
    // InternalModel.g:293:1: rule__Model__Group_4__0 : rule__Model__Group_4__0__Impl rule__Model__Group_4__1 ;
    public final void rule__Model__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:297:1: ( rule__Model__Group_4__0__Impl rule__Model__Group_4__1 )
            // InternalModel.g:298:2: rule__Model__Group_4__0__Impl rule__Model__Group_4__1
            {
            pushFollow(FOLLOW_5);
            rule__Model__Group_4__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Model__Group_4__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group_4__0"


    // $ANTLR start "rule__Model__Group_4__0__Impl"
    // InternalModel.g:305:1: rule__Model__Group_4__0__Impl : ( 'extends' ) ;
    public final void rule__Model__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:309:1: ( ( 'extends' ) )
            // InternalModel.g:310:1: ( 'extends' )
            {
            // InternalModel.g:310:1: ( 'extends' )
            // InternalModel.g:311:2: 'extends'
            {
             before(grammarAccess.getModelAccess().getExtendsKeyword_4_0()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getExtendsKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group_4__0__Impl"


    // $ANTLR start "rule__Model__Group_4__1"
    // InternalModel.g:320:1: rule__Model__Group_4__1 : rule__Model__Group_4__1__Impl ;
    public final void rule__Model__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:324:1: ( rule__Model__Group_4__1__Impl )
            // InternalModel.g:325:2: rule__Model__Group_4__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Model__Group_4__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group_4__1"


    // $ANTLR start "rule__Model__Group_4__1__Impl"
    // InternalModel.g:331:1: rule__Model__Group_4__1__Impl : ( ( rule__Model__ExtendedModelAssignment_4_1 ) ) ;
    public final void rule__Model__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:335:1: ( ( ( rule__Model__ExtendedModelAssignment_4_1 ) ) )
            // InternalModel.g:336:1: ( ( rule__Model__ExtendedModelAssignment_4_1 ) )
            {
            // InternalModel.g:336:1: ( ( rule__Model__ExtendedModelAssignment_4_1 ) )
            // InternalModel.g:337:2: ( rule__Model__ExtendedModelAssignment_4_1 )
            {
             before(grammarAccess.getModelAccess().getExtendedModelAssignment_4_1()); 
            // InternalModel.g:338:2: ( rule__Model__ExtendedModelAssignment_4_1 )
            // InternalModel.g:338:3: rule__Model__ExtendedModelAssignment_4_1
            {
            pushFollow(FOLLOW_2);
            rule__Model__ExtendedModelAssignment_4_1();

            state._fsp--;


            }

             after(grammarAccess.getModelAccess().getExtendedModelAssignment_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group_4__1__Impl"


    // $ANTLR start "rule__Model__NameAssignment_3"
    // InternalModel.g:347:1: rule__Model__NameAssignment_3 : ( RULE_MODEL_ID ) ;
    public final void rule__Model__NameAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:351:1: ( ( RULE_MODEL_ID ) )
            // InternalModel.g:352:2: ( RULE_MODEL_ID )
            {
            // InternalModel.g:352:2: ( RULE_MODEL_ID )
            // InternalModel.g:353:3: RULE_MODEL_ID
            {
             before(grammarAccess.getModelAccess().getNameMODEL_IDTerminalRuleCall_3_0()); 
            match(input,RULE_MODEL_ID,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getNameMODEL_IDTerminalRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__NameAssignment_3"


    // $ANTLR start "rule__Model__ExtendedModelAssignment_4_1"
    // InternalModel.g:362:1: rule__Model__ExtendedModelAssignment_4_1 : ( ( RULE_MODEL_ID ) ) ;
    public final void rule__Model__ExtendedModelAssignment_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:366:1: ( ( ( RULE_MODEL_ID ) ) )
            // InternalModel.g:367:2: ( ( RULE_MODEL_ID ) )
            {
            // InternalModel.g:367:2: ( ( RULE_MODEL_ID ) )
            // InternalModel.g:368:3: ( RULE_MODEL_ID )
            {
             before(grammarAccess.getModelAccess().getExtendedModelModelCrossReference_4_1_0()); 
            // InternalModel.g:369:3: ( RULE_MODEL_ID )
            // InternalModel.g:370:4: RULE_MODEL_ID
            {
             before(grammarAccess.getModelAccess().getExtendedModelModelMODEL_IDTerminalRuleCall_4_1_0_1()); 
            match(input,RULE_MODEL_ID,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getExtendedModelModelMODEL_IDTerminalRuleCall_4_1_0_1()); 

            }

             after(grammarAccess.getModelAccess().getExtendedModelModelCrossReference_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__ExtendedModelAssignment_4_1"


    // $ANTLR start "rule__Model__VersionAssignment_6"
    // InternalModel.g:381:1: rule__Model__VersionAssignment_6 : ( RULE_VERSION ) ;
    public final void rule__Model__VersionAssignment_6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalModel.g:385:1: ( ( RULE_VERSION ) )
            // InternalModel.g:386:2: ( RULE_VERSION )
            {
            // InternalModel.g:386:2: ( RULE_VERSION )
            // InternalModel.g:387:3: RULE_VERSION
            {
             before(grammarAccess.getModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); 
            match(input,RULE_VERSION,FOLLOW_2); 
             after(grammarAccess.getModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__VersionAssignment_6"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000050000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000020000L});

}