package org.xtext.example.model.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.model.services.ModelGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalModelParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_MODEL_ID", "RULE_VERSION", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'model'", "'{'", "'name'", "'extends'", "'version'", "'}'"
    };
    public static final int RULE_ID=6;
    public static final int RULE_WS=11;
    public static final int RULE_STRING=8;
    public static final int RULE_ANY_OTHER=12;
    public static final int RULE_SL_COMMENT=10;
    public static final int RULE_VERSION=5;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=7;
    public static final int T__18=18;
    public static final int RULE_ML_COMMENT=9;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int RULE_MODEL_ID=4;

    // delegates
    // delegators


        public InternalModelParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalModelParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalModelParser.tokenNames; }
    public String getGrammarFileName() { return "InternalModel.g"; }



     	private ModelGrammarAccess grammarAccess;

        public InternalModelParser(TokenStream input, ModelGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Model";
       	}

       	@Override
       	protected ModelGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleModel"
    // InternalModel.g:64:1: entryRuleModel returns [EObject current=null] : iv_ruleModel= ruleModel EOF ;
    public final EObject entryRuleModel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModel = null;


        try {
            // InternalModel.g:64:46: (iv_ruleModel= ruleModel EOF )
            // InternalModel.g:65:2: iv_ruleModel= ruleModel EOF
            {
             newCompositeNode(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleModel=ruleModel();

            state._fsp--;

             current =iv_ruleModel; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalModel.g:71:1: ruleModel returns [EObject current=null] : (otherlv_0= 'model' otherlv_1= '{' otherlv_2= 'name' ( (lv_name_3_0= RULE_MODEL_ID ) ) (otherlv_4= 'extends' ( (otherlv_5= RULE_MODEL_ID ) ) )? otherlv_6= 'version' ( (lv_Version_7_0= RULE_VERSION ) ) otherlv_8= '}' ) ;
    public final EObject ruleModel() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token lv_name_3_0=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token lv_Version_7_0=null;
        Token otherlv_8=null;


        	enterRule();

        try {
            // InternalModel.g:77:2: ( (otherlv_0= 'model' otherlv_1= '{' otherlv_2= 'name' ( (lv_name_3_0= RULE_MODEL_ID ) ) (otherlv_4= 'extends' ( (otherlv_5= RULE_MODEL_ID ) ) )? otherlv_6= 'version' ( (lv_Version_7_0= RULE_VERSION ) ) otherlv_8= '}' ) )
            // InternalModel.g:78:2: (otherlv_0= 'model' otherlv_1= '{' otherlv_2= 'name' ( (lv_name_3_0= RULE_MODEL_ID ) ) (otherlv_4= 'extends' ( (otherlv_5= RULE_MODEL_ID ) ) )? otherlv_6= 'version' ( (lv_Version_7_0= RULE_VERSION ) ) otherlv_8= '}' )
            {
            // InternalModel.g:78:2: (otherlv_0= 'model' otherlv_1= '{' otherlv_2= 'name' ( (lv_name_3_0= RULE_MODEL_ID ) ) (otherlv_4= 'extends' ( (otherlv_5= RULE_MODEL_ID ) ) )? otherlv_6= 'version' ( (lv_Version_7_0= RULE_VERSION ) ) otherlv_8= '}' )
            // InternalModel.g:79:3: otherlv_0= 'model' otherlv_1= '{' otherlv_2= 'name' ( (lv_name_3_0= RULE_MODEL_ID ) ) (otherlv_4= 'extends' ( (otherlv_5= RULE_MODEL_ID ) ) )? otherlv_6= 'version' ( (lv_Version_7_0= RULE_VERSION ) ) otherlv_8= '}'
            {
            otherlv_0=(Token)match(input,13,FOLLOW_3); 

            			newLeafNode(otherlv_0, grammarAccess.getModelAccess().getModelKeyword_0());
            		
            otherlv_1=(Token)match(input,14,FOLLOW_4); 

            			newLeafNode(otherlv_1, grammarAccess.getModelAccess().getLeftCurlyBracketKeyword_1());
            		
            otherlv_2=(Token)match(input,15,FOLLOW_5); 

            			newLeafNode(otherlv_2, grammarAccess.getModelAccess().getNameKeyword_2());
            		
            // InternalModel.g:91:3: ( (lv_name_3_0= RULE_MODEL_ID ) )
            // InternalModel.g:92:4: (lv_name_3_0= RULE_MODEL_ID )
            {
            // InternalModel.g:92:4: (lv_name_3_0= RULE_MODEL_ID )
            // InternalModel.g:93:5: lv_name_3_0= RULE_MODEL_ID
            {
            lv_name_3_0=(Token)match(input,RULE_MODEL_ID,FOLLOW_6); 

            					newLeafNode(lv_name_3_0, grammarAccess.getModelAccess().getNameMODEL_IDTerminalRuleCall_3_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getModelRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_3_0,
            						"org.xtext.example.model.Model.MODEL_ID");
            				

            }


            }

            // InternalModel.g:109:3: (otherlv_4= 'extends' ( (otherlv_5= RULE_MODEL_ID ) ) )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==16) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalModel.g:110:4: otherlv_4= 'extends' ( (otherlv_5= RULE_MODEL_ID ) )
                    {
                    otherlv_4=(Token)match(input,16,FOLLOW_5); 

                    				newLeafNode(otherlv_4, grammarAccess.getModelAccess().getExtendsKeyword_4_0());
                    			
                    // InternalModel.g:114:4: ( (otherlv_5= RULE_MODEL_ID ) )
                    // InternalModel.g:115:5: (otherlv_5= RULE_MODEL_ID )
                    {
                    // InternalModel.g:115:5: (otherlv_5= RULE_MODEL_ID )
                    // InternalModel.g:116:6: otherlv_5= RULE_MODEL_ID
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getModelRule());
                    						}
                    					
                    otherlv_5=(Token)match(input,RULE_MODEL_ID,FOLLOW_7); 

                    						newLeafNode(otherlv_5, grammarAccess.getModelAccess().getExtendedModelModelCrossReference_4_1_0());
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_6=(Token)match(input,17,FOLLOW_8); 

            			newLeafNode(otherlv_6, grammarAccess.getModelAccess().getVersionKeyword_5());
            		
            // InternalModel.g:132:3: ( (lv_Version_7_0= RULE_VERSION ) )
            // InternalModel.g:133:4: (lv_Version_7_0= RULE_VERSION )
            {
            // InternalModel.g:133:4: (lv_Version_7_0= RULE_VERSION )
            // InternalModel.g:134:5: lv_Version_7_0= RULE_VERSION
            {
            lv_Version_7_0=(Token)match(input,RULE_VERSION,FOLLOW_9); 

            					newLeafNode(lv_Version_7_0, grammarAccess.getModelAccess().getVersionVERSIONTerminalRuleCall_6_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getModelRule());
            					}
            					setWithLastConsumed(
            						current,
            						"Version",
            						lv_Version_7_0,
            						"org.xtext.example.model.Model.VERSION");
            				

            }


            }

            otherlv_8=(Token)match(input,18,FOLLOW_2); 

            			newLeafNode(otherlv_8, grammarAccess.getModelAccess().getRightCurlyBracketKeyword_7());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModel"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000030000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000040000L});

}